function CSum(x, y: Complex_Type): Complex_Type;
begin
        CSum := Complex(Re(x) + Re(y), Im(x) + Im(y));
end;

function CDiff(x, y: Complex_Type): Complex_Type;
begin
        CDiff := Complex(Re(x) - Re(y), Im(x) - Im(y));
end;

function CProd(x, y: Complex_Type): Complex_Type;
begin
        CProd := Complex(
                Re(x) * Re(y) - Im(x) * Im(y),
                Re(x) * Im(y) + Im(x) * Re(y)
        );
end;
