function CAbs(z: Complex_Type): Float;
begin
        CAbs := Sqrt(Sqr(Re(z)) + Sqr(Im(z)));
end;

procedure CPolar_form(z: Complex_Type; var r, theta: Float);
begin
        r := CAbs(z);
        if Re(z) > 0 then
                theta := ArcTan(Im(z) / Re(z))
        else
                if Re(z) < 0 then
                        theta := Pi + ArcTan(Im(z) / Re(z))
                else
                        if Im(z) >= 0 then
                                theta := 0.5 * Pi
                        else
                                theta := - 0.5 * Pi
end;

procedure CPrint(z: Complex_Type; n: Word);
begin
        if Re(z) < 0.0 then
                Write(' - ', Abs(Re(z)):(n + 2):n)
        else
                Write(' + ', Re(z):(n + 2):n);
        if Im(z) < 0.0 then
                Write(' - ', Abs(Im(z)):(n + 2):n)
        else
                Write(' + ', Im(z):(n + 2):n);
        Write('*i');
        WriteLn;
end;

begin
end.
