{$N+}
unit realpoly;
interface
type
        float = Extended;
        polynomial = ^term;
        term = record
                degree: Integer;
                coefficient: float;
                next: polynomial
        end;
function degree_poly(p: polynomial): Integer;
function leading_coeff(p: polynomial): float;
procedure insert_term(t: term; var p: polynomial; augment: Boolean);
procedure load(var p: polynomial);
procedure recycle(var p: polynomial);
function copy_poly(p: polynomial): polynomial;
procedure print_poly(p: polynomial);
function mult_by_scalar(c: float; p: polynomial): polynomial;
function sum_poly(p, q: polynomial): polynomial;
function product_poly(p, q: polynomial): polynomial;
function derivative_poly(p: polynomial): polynomial;
procedure division_poly(f, g: polynomial; var q, r: polynomial);
function value_poly(p: polynomial; c: float): float;
procedure evaluate_poly(p: polynomial; c: float; var D0, D1: float);
