procedure load(var p: polynomial);
var
        t: term;
        k: Integer;
begin
        p := nil;
        t.next := nil;
        repeat
                Write(' ⥯  童 ( -1  室): ');
                ReadLn(k);
                if k >= 0 then
                begin
                        with t do
                        begin
                                degree := k;
                                Write(' 樥: ');
                                ReadLn(coefficient);
                        end;
                        insert_term(t, p, False);
                end;
        until k < 0;
end;

procedure recycle(var p: polynomial);
begin
        if p <> nil then
        begin
                recycle(p^.next);
                Dispose(p);
        end;
        p := nil;
end;

function copy_poly(p: polynomial): polynomial;
var
        s: polynomial;
begin
        if p = nil then
                s := nil
        else
        begin
                New(s);
                s^ := p^;
                s^.next := copy_poly(p^.next);
        end;
        copy_poly := s;
end;

procedure print_poly(p: polynomial);
var
        run: polynomial;
        k: Integer;
begin
        if p = nil then
                WriteLn(0:2)
        else
        begin
                with p^ do
                begin
                        Write(coefficient:5:5);
                        if degree > 0 then Write(' x^', degree);
                        run := next;
                end;
                k := 4;
                while run <> nil do
                begin
                        Dec(k);
                        if k = 0 then
                        begin
                                k := 5;
                                WriteLn;
                                Write(' ':15);
                        end;
                        with run^ do
                        begin
                                if coefficient < 0.0 then
                                        Write(' - ', -coefficient:5:5)
                                else
                                        Write(' + ', coefficient:5:5);
                                if degree > 0 then
                                        Write(' x^', degree);
                                run := next;
                        end
                end;
                WriteLn;
        end
end;
