procedure division_poly(f, g: polynomial;
                var q, r: polynomial);
var
        run, h, temp: polynomial;
        t: term;
        gap, d: Word;
        a: float;
begin
        q := nil;
        d := degree_poly(g);
        r := copy_poly(f);
        while degree_poly(r) >= d do
        begin
                gap := degree_poly(r) - d;
                a := leading_coeff(r) / leading_coeff(g);
                h := copy_poly(g); run := h;
                repeat
                        with run^ do
                        begin
                                degree := gap + degree;
                                coefficient := -a * coefficient;
                                run := next;
                        end
                until run = nil;
                temp := sum_poly(r, h);
                recycle(r);
                recycle(h);
                r := nil;
                t.degree := gap; t.coefficient := a;
                insert_term(t, q, false);
        end;
end;
