{$M 4096, 0, 0}
program execute_at_time;

uses Crt, Dos;

var
        time_to_run, program_to_run, cur_time: String;
        h_str, m_str, s_str, hnd_str: String[2];
        ch: Char;
        hours, minutes, seconds, hunds: Byte;

procedure current_time(var hrs, min, sec, hnd: Byte);
var
        regs: Registers;
begin
        with regs do
        begin
                ax := 44 shl 8;
                MsDos(regs);
                hrs := ch;
                min := cl;
                sec := dh;
                hunds := dl;
        end;
end;

procedure cursor_off;
var
        regs: Registers;
begin
        regs.ax := $0100;
        regs.cx := $2607;
        Intr($10, regs);
end;

procedure cursor_on;
var
        regs: Registers;
begin
        regs.ax := $0100;
        regs.cx := $0506;
        Intr($10, regs);
end;

procedure input(var time, command: String);
var
        loop: Integer;
        p1,p2: String;
        found_time: Boolean;
begin
        if (paramcount <> 2) then
        begin
                WriteLn;
                WriteLn(' ᯮ짮: attime :: ');
                WriteLn;
                cursor_on;
                Halt;
        end
        else
        begin
                found_time := False;
                p1 := paramstr(1);
                p2 := paramstr(2);
                loop := Pos(':', p1);
                if loop <> 0 then
                begin
                        found_time := True;
                        time := p1;
                        command := p2;
                end;
                if not found_time then loop := Pos(':', p2);
                if loop = 0 then
                begin
                        found_time := True;
                        time := p2;
                        command := p1;
                end;
                if not found_time then
                begin
                        WriteLn;
                        WriteLn('ᯮ짮: attime :: ');
                        WriteLn;
                        cursor_on;
                        Halt;
                end;
        end;
end;

function time_rest(r_time: String): String;
var
        hours_to_run, minutes_to_run, seconds_to_run: Byte;
        code: Integer;
        str1, str2, str3: String[2];
        tmp1, tmp2, tmp3, time_rest_to_start: LongInt;
const
        seconds_in_a_day: LongInt = 86400;
begin
        Val(Copy(r_time, 1, 2), hours_to_run, code);
        Val(Copy(r_time, 4, 2), minutes_to_run, code);
        Val(Copy(r_time, 7, 2), seconds_to_run, code);

        tmp3 := seconds_to_run - seconds;
        tmp2 := minutes_to_run - minutes;
        tmp1 := hours_to_run - hours;

        time_rest_to_start := tmp1 * 3600 + tmp2 * 60 + tmp3;

        if time_rest_to_start < 0 then
                time_rest_to_start := time_rest_to_start + seconds_in_a_day;
        tmp1 := time_rest_to_start div 3600;
        tmp2 := time_rest_to_start mod 3600 div 60;
        tmp3 := time_rest_to_start - tmp1 * 3600 - tmp2 * 60;

        Str(tmp3, str3);
        if Length(str3) = 1 then str3 := '0' + str3;

        Str(tmp2, str2);
        if Length(str2) = 1 then str2 := '0' + str2;

        Str(tmp1, str1);
        if Length(str1) = 1 then str1 := '0' + str1;

        time_rest := str1 + ':' + str2 + ':' + str3;
end;

procedure beep;
begin
        Sound(500);
        Delay(1000);
        NoSound;
end;

begin
        checkbreak := False;
        cursor_off;
        input(time_to_run, program_to_run);
        ClrScr;
        GotoXY(20, 10);
        WriteLn('------------------------------------');
        GotoXY(20, 11);
        WriteLn('|                                   |');
        GotoXY(20, 12);
        WriteLn('| 饥 ६       :             |');
        GotoXY(20, 13);
        WriteLn('| ६         :             |');
        GotoXY(20, 14);
        WriteLn('|  ᪠ ⠫ :             |');
        GotoXY(20, 15);
        WriteLn('| ணࠬ           :             |');
        GotoXY(20, 16);
        WriteLn('|                                   |');
        GotoXY(20, 17);
        WriteLn('-------------------------------------');
        GotoXY(20, 18);
        WriteLn('         |  alt-x : 室  |         ');
        GotoXY(20, 19);
        WriteLn('         -------------------         ');
        GotoXY(44, 13);
        WriteLn(time_to_run);
        GotoXY(44, 15);
        WriteLn(program_to_run);

        repeat
                current_time(hours, minutes, seconds, hunds);
                Str(hours, h_str);
                if hours = 0 then h_str:='00';
                Str(minutes, m_str);
                Str(seconds ,s_str);
                Str(hunds, hnd_str);

                if Length(m_str) = 1 then m_str := '0' + m_str;
                if Length(s_str) = 1 then s_str := '0' + s_str;
                cur_time := h_str + ':' + m_str + ':' + s_str + ':' + hnd_str;

                if KeyPressed then
                begin
                        ch := ReadKey;
                        if ch = #0 then
                        begin
                                ch := ReadKey;
                                if ch = 'X' then
                                begin
                                        cursor_on;
                                        ClrScr;
                                        Halt;
                                end;
                        end;
                end;
                GotoXY(44, 12);
                WriteLn(cur_time);
                GotoXY(44, 14);
                WriteLn(time_rest(time_to_run));
        until time_to_run = Copy(cur_time, 1, 8);
        
        ClrScr;
        Exec(GetEnv('comspec'),'/c '+ program_to_run);
        cursor_on;
end.
