program test_intr_10;
uses Dos, Crt;
var
        top, bottom, x, y, attr, k: Byte;
        ss: String;
        reg: Registers;

procedure display_page(page: Byte);
begin
        reg.AH := $05;
        reg.AL := page;
        Intr($10, reg);
end;

procedure set_cursor_position(page, x, y: Byte);
begin
        with reg do
        begin
                AH := $02;
                BH := page;
                DH := y;
                DL := x;
        end;
        Intr($10, reg);
end;

procedure write_chars(page, x, y: Byte; ch0: Char; attr: Byte; multiplicity: Word);
begin
        set_cursor_position(page, x, y);
        with reg do
        begin
                AH := $09;
                AL := Ord(ch0);
                BH := page;
                BL := attr;
                CX := multiplicity;
        end;
        Intr($10, reg);
end;

procedure write_string(page, x, y: Byte; ss: String; attr: Byte);
var
        j: Word;
begin
        for j := 1 to Length(ss) do
        begin
                write_chars(page, x, y, ss[j], attr, 1);
                Inc(x);
        end;
end;

begin
        ClrScr;
        WriteLn(' ᯮ짮 뢠 10');
        WriteLn(' ࠡ  ⥪⮢ ࠭');
        Write(' <Enter>');
        ReadLn;
        for k := 0 to 7 do
        begin
                write_chars(k, 0, 0, ' ', black, 80);
                attr := 128 * (k mod 2) + k shl 4 + k + 8;
                write_chars(k, 0, 1, Chr(177), attr, 80 * 24);
                write_string(k, 0, 0, '࠭ ' + Chr(48 + k) + '   ', k + 8);
                display_page(k);
                Delay(1000);
        end;
        write_string(7, 40, 4, ' <Enter>:  ', Yellow);
        ReadLn;
end.
