program test_text_video;

uses Dos, Crt;

const
        ss: array[1..12] of String[40] =(
                        '           HAPPY HALLOWEEN!!!!          ',
                        '                                        ',
                        '        oooooooooooooooooooooooo        ',
                        '     oooooooooooooooooooooooooooooo     ',
                        '  oooooooo     oooooooooo     oooooooo  ',
                        ' ooooooooo     oooooooooo     ooooooooo ',
                        'oooooooooo     oooooooooo     oooooooooo',
                        'oooooooooooooooooooooooooooooooooooooooo',
                        ' oooooooooooooooooooooooooooooooooooooo ',
                        '   oooooooooo               ooooooooo   ',
                        '      oooooooooo         ooooooooo      ',
                        '               ooooooooooo              ');

var
        x, y, n, attr,k, col, row: Byte;
        reg: Registers;

procedure up(x0, y0, x1, y1, n, attr: Byte);
begin
        with reg do
        begin
                ah := $06;
                al := n;
                bh := attr;
                cl := x0; ch := y0;
                dl := x1; dh := y1;
        end;
        Intr($10, reg);
end;

procedure down(x0, y0, x1, y1, n, attr: Byte);
begin
        with reg do
        begin
                ah := $07;
                al := n;
                bh := attr;
                cl := x0; ch := y0;
                dl := x1; dh := y1;
        end;
        Intr($10, reg);
end;

procedure set_cursor_position(page, x, y: Byte);
begin
        with reg do
        begin
                AH := $02;
                BH := page;
                DH := y;
                DL := x;
        end;
        Intr($10, reg);
end;

procedure write_chars(page, x, y: Byte; ch0: Char; attr: Byte; multiplicity: Word);
begin
        set_cursor_position(page, x, y);
        with reg do
        begin
                AH := $09;
                AL := Ord(ch0);
                BH := page;
                BL := attr;
                CX := multiplicity;
        end;
        Intr($10, reg);
end;

procedure write_string(page, x, y: Byte; ss: String; attr: Byte);
var
        j: Word;
begin
        for j := 1 to Length(ss) do
        begin
                write_chars(page, x, y, ss[j], attr, 1);
                Inc(x);
        end;
end;

begin
        up(0, 0, 79, 24, 0, black);
        attr := yellow;
        for row := 1 to 12 do
                write_string(0, 20, row, ss[row], attr);
        for row := 1 to 12 do
                write_chars(0, 0, row, ' ', black, col);
        k := 0;
        repeat
                Inc(k);
                if Odd(k) then
                        for row := 0 to 9 do
                        begin
                                Delay(100);
                                down(0, 0, 79, 24, 1, black);
                        end
                else
                        for row := 0 to 9 do
                        begin
                                Delay(100);
                                up(0, 0, 79, 24, 1, green);
                        end;
                Sound(200); Delay(10); NoSound;
        until KeyPressed;
end.
