program test_Graph_unit;

uses Crt, Dos, Graph;
var
        x, y, xx, yy: Integer;
        ch: Char;
        s: String;
        ptr: Pointer;
        size: Word;

procedure test_fill_styles;
procedure fill(x, y, style: Integer; color: Word; ss: String);

var
        prev_color: Word;

begin
        prev_color := GetColor;
        SetColor(White);
        OutTextXY(x, y - 15, ss);
        SetColor(prev_color);
        SetFillStyle(style, color);
        Rectangle(x, y, x + 90, y + 90);
        Bar(x + 1, y + 1, x + 89, y + 89);
end;{fill}

begin
        fill( 50, 70,  EmptyFill,       1, 'EmptyFill');
        fill(200, 70,  SolidFill,       2, 'SolidFill');
        fill(350, 70,  LineFill,        3, 'LineFill');
        fill(500, 70,  LtSlashFill,     4, 'LtSlashFill');
        fill( 50, 215, SlashFill,       5, 'SlashFill');
        fill(200, 215, BkSlashFill,     6, 'BkSlashFill');
        fill(350, 215, LtBkSlashFill,   7, 'LtBkSlashFill');
        fill(500, 215, HatchFill,       8, 'HatchFill');
        fill( 50, 345, XHatchFill,      9, 'XHatchFill');
        fill(200, 345, InterleaveFill, 10, 'InterleaveFill');
        fill(350, 345, WideDotFill,    11, 'WideDotFill');
        fill(500, 345, CloseDotFill,   12, 'CloseDotFill');
end;{test_fill_styles}

procedure fill_bar(x, y, xx, yy: Integer; color, raster: Byte);

const
        fil_pat :array[0..27] of FillPatternType =(
                ($ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff),
                (0, $fb, $fb, $fb, 0, $df, $df, $df),
                (0, $10, $28, $44, $28, $10, 0, 0),
                ($22, 0, $88, 0, $22, 0, $88, 0),
                ($cc, $33, $cc, $33, $cc, $33, $cc, $33),
                ($aa, $55, $aa, $55, $aa, $55, $aa, $55),
                ($94, $84, $48, $30, 0, $c1, $22, $14),
                ($aa, $aa, $aa, $aa, $aa, $aa, $aa, $aa),
                ($ff, 0, $ff, 0, $ff, 0, $ff, 0),
                ($ff, $1, $7d, $45, $5d, $41, $7f, 0),
                ($01, $82, $44, $28, $10, $20, $40, $80),
                (0, $3c, $42, $42, $42, $42, $3c, 0),
                (0, $7e, $7e, $7e, $7e, $7e, $7e, 0),
                ($81, $42, $24, $18, $18, $24, $42, $81),
                (0, $ec, $2a, $2a, $2a, $aa, $ec, 0),
                (0, $08, $18, $3f, $3f, $18, $08, 0),
                (0, 0, $7e, $42, $7e, $42, $7e, $42),
                ($80, $7f, $41, $41, $41, $41, $41, $7f),
                (0, $5d, $3e, $6b, $7f, $63, $36, $5d),
                (0, 0, $04, $08, $90, $a0, $c0, $f0),
                ($92, $24, $49, $92, $24, $49, $92, $24),
                ($b1, $22, $14, $14, $22, $91, $48, $24),
                ($18, $3c, $3c, $7e, $7e, $3c, $3c, $18),
                ($e7, $c3, $81, $18, $18, $81, $c3, $e7),
                ($2, $91, $68, $8, $10, $16, $89, $40),
                ($ff, $81, $81, $81, $81, $81, $81, $ff),
                (0, 0, $81, $81, $42, $24, $18, $18),
                ($c3, $42, $5a, $7e, $7e, $5a, $42, $c3));

begin
        if raster < 28 then
        begin
                SetFillPattern(fil_pat[raster], color);
                SetFillStyle(12, color);
                Bar(x, y, xx, yy);
        end;
end;{fill_bar}
