procedure horizontal_reflection(mx, my, mxx, myy: Integer);
var
        pix1, pix2: Integer;
begin
        if (mx < 0) or (my < 0) or (mxx > GetMaxX) or
                (myy > GetMaxY) then Exit;
        for x := mx to mxx do

                for y := my to (my + myy) div 2 do

                begin
                        pix1 := GetPixel(x, y);
                        pix2 := GetPixel(x, my + myy - y);
                        PutPixel(x, my + myy - y, pix1);
                        PutPixel(x, y, pix2);
                end;
end;

procedure vertical_reflection(mx, my, mxx, myy: Integer);
var
        pix1, pix2: Integer;
begin
        if (mx < 0) or (my < 0) or (mxx > GetMaxX) or
                (myy > GetMaxY) then Exit;
        for y := my to myy do
                for x := mx to (mx + mxx) div 2 do
                begin
                        pix1 := GetPixel(x, y);
                        pix2 := GetPixel(mx + mxx - x, y);
                        PutPixel(mx + mxx - x, y, pix1);
                        PutPixel(x, y, pix2);
                end;
end;
