program pixel;
uses Crt, Dos;
type
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;

var
        screen: screenbufferptr;
        hres, vres: Word;
        color: Byte;

procedure init_graph;
var
        regs: Registers;
begin
        regs.ah := $00;
        regs.al := $13;
        Intr($10, regs);
        screen := Ptr($a000, 0);
end;

procedure close_graph;
var
        regs: Registers;
begin
        regs.ah := $00;
        regs.al := $03;
        Intr($10, regs);
end;

procedure set_pixel(x, y: Word; color: Byte);
var
        address: Word;
begin
        address := y * 320 + x;
        screen^[address] := color;
end;

begin
        hres := 320; vres := 200; color := 255;
        Randomize;
        init_graph;
        repeat
                set_pixel(Random(hres), Random(vres), Random(color + 1));
        until KeyPressed;
        close_graph;
end.
