program bresenline;

uses
        Crt, Dos;

type
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;
        screentype = record
                buffer: screenbufferptr;
                ytable: array[0..199] of Word;
                width, color: Word;
        end;

var
        screen: screentype;
        screen_y: array[0..199] of Word;
        i, j: Word;

procedure calcscreeny(width: Word);
...

procedure init_graph;
...

procedure close_graph;
...

procedure set_pixel(x, y: Word; color: Byte);
...

procedure bresenhamline(x1, y1, x2, y2: Word; color: Byte);
var
        deltax, deltay, inc1, inc2, d, x, y: Integer;
begin
        deltax := x2 - x1;
        deltay := y2 - y1;
        d := 2 * deltay - deltax;
        inc1 := deltay shl 1;
        inc2 := (deltay - deltax) shl 1;
        x := x1; y := y1;
        set_pixel(x, y, color);
        while x < x2 do
        begin
                if d < x1 then
                begin
                        d := d + inc1;
                        Inc(x);
                end
                else
                begin
                        d := d + inc2;
                        Inc(x);
                        Inc(y);
                end;
                set_pixel(x, y, color);
        end;
end;

begin
        init_graph;
        bresenhamline(0, 0, 319, 199, 15);
        ReadLn;
        close_graph;
end.
