program koch;

uses
        Crt, Graph, graphs;

var
        ch: Char;
        min: Word;

procedure rotate_plus(var x, y: Integer);
var
        t: Integer;
begin
        t := x;
        x := y;
        y := -t;
end;

procedure rotate_minus(var x, y: Integer);
var
        t: Integer;
begin
        t := x;
        x := -y;
        y := t;
end;

procedure draw(x, y: Integer; length: Word);
var
        t: Word;
begin
        if KeyPressed then
                Exit;
        if length >= min then
        begin
                if length >= 32 then
                        SetLineStyle(SolidLn, 0, ThickWidth)
                else
                        SetLineStyle(SolidLn, 0, NormWidth);
                t := length div 4;
                SetColor(White);
                draw(x, y, t);
                SetColor(Yellow);
                rotate_plus(x, y);
                draw(x, y, t);
                SetColor(Magenta);
                rotate_minus(x, y);
                draw(x, y, t);
                rotate_minus(x, y);
                SetColor(Red);
                draw(x, y, t);
                SetColor(Cyan);
                draw(x, y, t);
                rotate_plus(x, y);
                SetColor(Green);
                draw(x, y, t);
                SetColor(Blue);
                rotate_plus(x, y);
                draw(x, y, t);
                SetColor(LightGray);
                rotate_minus(x, y);
                draw(x, y, t);
        end
        else
                LineRel(length * x, length * y);
end;

begin
        open_graph;
        min := 256;
        while min >= 4 do
        begin
                MoveTo(20, 200);
                draw(1, 0, 512);
                OutTextXY(200, 460, 'Press <Space>:');
                ch := ReadKey;
                min := min div 4;
                ClearDevice;
        end;
        close_graph;
end.
