program cantor;

uses
        Crt, Graph, graphs;

var
        ch: Char;

procedure draw(x, y: Integer; size: Word);
var
        s: Word;

procedure solid_rectangle(x, y, size: Integer);

begin
        Rectangle(x - size, y - size, x + size, y + size);
        Bar(x - size + 1, y - size + 1, x + size - 1, y + size - 1);
end;

begin
        if size > 1 then
        begin
                s := size div 2;
                draw(x - size, y + size, s);
                draw(x - size, y - size, s);
                draw(x + size, y + size, s);
                draw(x + size, y - size, s);
        end;
        solid_rectangle(x, y, size);
end;

begin
        open_graph;
        SetFillStyle(SolidFill, Black);
        SetColor(Yellow);
        draw(GetMaxX div 2, GetMaxY div 2, GetMaxY div 4);
        OutTextXY(265, 235, 'Press <Enter>');
        ReadLn;
        close_graph;
end.
