implementation

constructor matrix_obj.init;
begin
end;

procedure matrix_obj.set_to_zero(var p: Pointer);
begin
end;

procedure matrix_obj.scalar_sum(const p, q: Pointer; var r: Pointer);
begin
end;

procedure matrix_obj.scalar_product(const p, q: Pointer; var r: Pointer);
begin
end;

procedure matrix_obj.matrix_sum(const A, B: matrix);
var
        i, j: Word;
begin
        for i := 1 to max do
                for j := 1 to max do
                        scalar_sum(A[i, j], B[i, j], M[i, j]);
end;

procedure matrix_obj.matrix_product(const A, B: matrix);
var
        i, j, k: Word;
        prod, sum: Pointer;
begin
        GetMem(prod, SizeOf(M[1, 1]));
        for i := 1 to max do
                for k := 1 to max do
                begin
                        sum := M[i, k];
                        set_to_zero(sum);
                        for j := 1 to max do
                        begin
                                scalar_product(A[i, j], B[j, k], prod);
                                scalar_sum(sum, prod, sum);
                        end;
        end;
        FreeMem(prod, SizeOf(M[1, 1]));
end;

procedure matrix_obj.convert_to_string(p: Pointer; var tt: str30);
begin
end;

procedure matrix_obj.print(name: str10);
var
        i, j, k, hold_y: Word;
        temp: str30;
begin
        hold_y := WhereY;
        GotoXY(1, hold_y + (max + 1) div 2);
        Write(name, ' = ');
        k := Length(name) + 4;
        GotoXY(k, hold_y); Write('-');
        for i := 1 to max do
        begin
                GotoXY(k, hold_y + i);
                Write('|');
                for j := 1 to max do
                begin
                        convert_to_string(M[i, j], temp);
                        Write(temp);
                end;
                Write('|');
        end;
        GotoXY(k, max + hold_y + 1); Write('L');
        GotoXY(k + Length(temp) * max + 1, hold_y);
        Write('');
        GotoXY(k + Length(temp) * max + 1, max + hold_y + 1);
        WriteLn('-');
end;

destructor matrix_obj.done;
begin
end;

constructor real_matrix_obj.init(M0: real_matrix);
var
        i, j: Word;
begin
        inherited init;
        for i := 1 to max do
                for j := 1 to max do
                begin
                        New(real_ptr(M[i, j]));
                        real_ptr(M[i, j])^ := M0[i, j];
                end;
end;

procedure real_matrix_obj.set_to_zero(var p: Pointer);
begin
        real_ptr(p)^ := 0.0;
end;

procedure real_matrix_obj.scalar_sum(const p, q: Pointer; var r: Pointer);
begin
        if not Assigned(r) then
                New(real_ptr(r));
        real_ptr(r)^ := real_ptr(p)^ + real_ptr(q)^;
end;

procedure real_matrix_obj.scalar_product(const p, q: Pointer; var r: Pointer);
begin
        if not Assigned(r) then
                New(real_ptr(r));
        real_ptr(r)^ := real_ptr(p)^ * real_ptr(q)^;
end;

procedure real_matrix_obj.convert_to_string(p: Pointer; var tt: str30);
begin
        Str(real_ptr(p)^:9:4, tt);
end;

destructor real_matrix_obj.done;
var
        i, j: Word;
begin
        for i := 1 to max do
                for j := 1 to max do
                begin
                        Dispose(real_ptr(M[i, j]));
                end;
        inherited done;
end;
