program eratosphen2;

uses
        Crt;

const
        n = 20;
        m = n * n;

var
        p, s, i, j, k: Word;
        accept: Boolean;
        prime: array[1..m - 1] of Word;
        mult: array[1..n - 1] of Word;
        old_mode: Integer;

begin
        ClrScr;
        prime[1] := 2;
        p := 2;
        k := 1;
        s := Sqr(prime[1]);
        for i := 2 to m - 1 do
        begin
                repeat
                        Inc(p);
                        if s <= p then
                        begin
                                mult[k] := s;
                                Inc(k);
                                s := Sqr(prime[k]);
                        end;
                        accept := True;
                        for j := 1 to k - 1 do
                        begin
                                if mult[j] < p then
                                        mult[j] := mult[j] + prime[j];
                                accept := (mult[j] > p);
                                if not accept then
                                        Break;
                        end;
                until accept;
                prime[i] := p;
        end;
        WriteLn;
        WriteLn;
        old_mode := lastmode;
        TextMode(CO80 + font8x8);
        for i := 1 to 10 do
                Write(i:8); WriteLn;
        TextColor(Yellow);
        for i := 1 to m - 1 do
                Write(prime[i]:8);
        WriteLn;
        WriteLn;
        TextColor(LightGray);
        Write(' <Enter>');
        ReadLn;
        TextMode(old_mode);
end.
