unit orthpoly;

interface

function Chebyshev(degree: Word; x: Real): Real;

implementation

function Chebyshev(degree: Word; x: Real): Real;

var
        Pn, Pn_1, Pn_2: Real;
        k: Word;

begin
        if degree = 0 then
                Chebyshev := 1.0
        else
        begin
                Pn_1 := 1.0;
                Pn := x;
                for k := 2 to degree do
                begin
                        Pn_2 := Pn_1;
                        Pn_1 := Pn;
                        Pn := 2.0 * x * Pn_1 - Pn_2;
                end;
                Chebyshev := Pn;
        end;
end;

end.
