unit series;

interface

const
        max_deg = 20;
        eta = 1.0e-20;

type
        power_series = array[0..max_deg] of Real;

var
        Zero, One: power_series;
        k: Word;

procedure quotient(const F, G: power_series; var H: power_series);
procedure composition(const F, G: power_series; var H: power_series);
procedure invert(const F: power_series; var H: power_series);
procedure nth_power(const F: power_series; n: Word; var G: power_series);
