procedure invert(const F: power_series; var H: power_series);

var
        P: power_series;
        k, m: Word;

procedure truncated_product(var P: power_series; m: Word);

var
        j, k: Word;
        sum: Real;

begin
        for j := m downto 1 do
        begin
                sum := 0;
                for k := 1 to j do
                        sum := sum + P[j - k] * H[k];
                P[j] := sum;
        end;
        P[0] := 0.0;
end;{truncated_product}

begin{invert}
        if (F[0] <> 0.0) or (F[1] <> 1.0) then
                Halt;
        H := Zero;
        H[1] := 1.0;
        for m := 2 to max_deg do
        begin
                P := Zero;
                for k := m downto 2 do
                begin
                        P[0] := -F[k];
                        truncated_product(P, m);
                end;
                truncated_product(P, m);
                P[1] := P[1] + 1.0;
                H := P;
        end;
end;{invert}
