unit lin_alg;

{ $define complete_pivot }

interface

const
        max_no_rows = 20;

type
        matrix = array[1..max_no_rows, 1..2 * max_no_rows] of Real;
        str10 = String[10];

var
        no_rows, no_cols: Word;
        singular: Boolean;

procedure get_system_matrix(var A: matrix);
procedure get_rhs(var A: matrix);
procedure print_matrix(const A: matrix; name: str10;
                screen_row, first_col, last_col: Word);
procedure triangularize(var A: matrix);
procedure back_subtract(var A: matrix);
