implementation

uses
        Crt;

var
        zero, weight: array[1..max_deg] of Real;

function simpson(F: real_fun; x0, x1: Real; div_no: Word): Real;

var
        x, dx, sum: Real;
        j: Word;

begin
        dx := (x1 - x0) / (2.0 * div_no);
        sum := F(x0) + F(x1);
        x := x0;
        for j := 1 to 2 * div_no - 1 do
        begin
                x := x + dx;
                if Odd(j) then
                        sum := sum + 4.0 * F(x)
                else
                        sum := sum + 2.0 * F(x);
        end;
        simpson := dx * sum / 3.0;
end;
