unit fileunit;

interface

uses Dos;

type
        message = String[60];

var
        name: namestr;
        file_done: Boolean;

procedure get_file_name(prompt: message; var name: PathStr);
procedure test_error(var fname: PathStr);
procedure file_input(mess: PathStr; var GG: text);
procedure file_output(mess: PathStr; var GG: text);
procedure file_copy(file_src, file_dest: PathStr; OverWrite: Boolean);
procedure file_merge(file_src, file_dest: PathStr);
procedure file_delete(file_dest: PathStr);
procedure file_rename(file_src, file_dest: PathStr; OverWrite: Boolean);

function file_exist_check(Name: PathStr): Boolean;
function get_file_extension(S: PathStr): String;
function get_file_prefix(S: PathStr): String;
function get_file_dir(S: PathStr): String;
