program day_of_week;

uses Crt;

const
        DayOfWeek: array [0..6] of String = (
                '쭨', '୨', '।', '⢥',
                '⭨', '㡡', 'ᥭ'
        );

type
        pString = ^String;

var
        year, month, day: Word;

function IntDow(yyyy, mm, dd: Integer): Integer;
var
        AddVal: ShortInt;
begin
        if mm < 3 then
                AddVal := 1
        else
                AddVal := 0;
        IntDow := (((3 * yyyy - (7 * (yyyy + (mm + 9) div 12)) div 4 +
                (23 * mm) div 9 + dd + 2 + ((yyyy - AddVal) div 100 + 1) *
                3 div 4 - 16) mod 7));
end;

function StrDow(yyyy, mm, dd: Integer): pString;
begin
        StrDow := @DayOfWeek[IntDow(yyyy, mm, dd)];
end;

begin
        ClrScr;
        TextColor(7);
        WriteLn;
        Write('    : ');
        ReadLn(year);
        Write('  : ');
        ReadLn(month);
        Write('   : ');
        ReadLn(day);
        WriteLn;
        TextColor(11);
        WriteLn(day,'.',month,'.',year,' -    ', StrDow(year, month, day)^);
        WriteLn(' <Enter>:');
        ReadLn;
end.
