procedure product_matrix(var A, B, C: matrix);
var
        i, j, k: Word;
        sum: LongInt;
begin
        if A.no_cols <> B.no_rows then Halt;
        create_matrix(C, A.no_rows, B.no_cols);
        for i := 1 to A.no_rows do
                for k := 1 to B.no_cols do
                begin
                        sum := 0;
                        for j := 1 to A.no_cols do
                                sum := sum +
                                        A.index_ptr^[i]^[j] * B.index_ptr^[j]^[k];
                        C.index_ptr^[i]^[k] := sum;
                end;
end;

procedure print_matrix(var A: matrix; ss: String);
var
        i, k: Word;
begin
        with A do
        begin
                WriteLn(ss);
                for i := 1 to no_rows do
                begin
                        for k := 1 to no_cols do
                                Write(index_ptr^[i]^[k]:4);
                        WriteLn;
                end;
        end;
end;
