function mult_by_scalar(c: float; p: polynomial): polynomial;
var
        r, s: polynomial;
begin
        s := copy_poly(p);
        r := s;
        while r <> nil do
                with r^ do
                begin
                        coefficient := c * coefficient;
                        r := next
                end;
        mult_by_scalar := s;
end;

function sum_poly(p, q: polynomial): polynomial;
var
        p_run, s: polynomial;
        t: term;
begin
        s := copy_poly(p);
        p_run := q;
        while p_run <> nil do
        begin
                t := p_run^;
                t.next := nil;
                insert_term(t, s, true);
                p_run := p_run^.next;
        end;
        sum_poly := s;
end;
