function value_poly(p: polynomial; c: float): float;
var
        i, k: Integer;
        s: float;
        run: polynomial;
begin
        if p = nil then
                s := 0.0
        else
                s := p^.coefficient;
        run := p;
        while run <> nil do
        begin
                if run^.next = nil then
                        k := degree_poly(run)
                else
                        k := degree_poly(run) - degree_poly(run^.next);
                for i := k downto 1 do
                        s := s * c;
                run := run^.next;
                if run <> nil then
                        s := s + run^.coefficient;
        end;
        value_poly := s;
end;

procedure evaluate_poly(p: polynomial; c: float;
                var D0, D1: float);
var
        i, gap: Integer;
        run: polynomial;
begin
        D1 := 0;
        if p = nil then
        begin
                D0 := 0.0;
                Exit;
        end;
        D0 := p^.coefficient;
        run := p;
        while run <> nil do
        begin
                if run^.next = nil then
                        gap := degree_poly(run)
                else
                        gap := degree_poly(run) - degree_poly(run^.next);
                for i := gap downto 1 do
                begin
                        D1 := D1 * c + D0;
                        D0 := D0 * c;
                end;
                run := run^.next;
                if run <> nil then
                        D0 := D0 + run^.coefficient;
        end;
end;
end.
