unit mouse;

interface

type
        Str6 = String[6];

procedure reset_mouse(var mouse_OK: Boolean; var button: Byte);
procedure show_cursor;
procedure hide_cursor;
procedure get_mouse_status(var button: Byte; var x, y: Word);
procedure mouse_gotoXY(x, y: Word);
procedure get_mouse_button_press(var button: Byte; var count, x, y: Word);
function double_click(timeout: Word): Boolean;
procedure get_mouse_button_release(var button: Byte; var count, x, y: Word);
procedure set_cursor_x_lim(min_x, max_x: Word);
procedure set_cursor_y_lim(min_y, max_y: Word);
procedure set_graph_cursor_shape(hot_x, hot_y: Integer; address: Pointer);
procedure set_text_cursor_shape(screen_mask, cursor_mask: Word);
procedure get_relative_move(var x, y: Integer);
procedure set_hide_cursor_window(x0, y0, x1, y1: Word);
procedure get_mouse_state_size(var size: Word);
procedure save_mouse_driver_state(address: Pointer);
procedure restore_mouse_driver_state(address: Pointer);
procedure get_mouse_page(var page: Word);
procedure set_mouse_page(page: Word);
procedure reset_mouse_software(var installed: Boolean; var no_buttons: Word);
procedure get_mouse_info(var ver: Str6; var port, IRQ: Byte);
