procedure get_mouse_state_size(var size: Word);
begin
        regs.AX := $15;
        Intr($33, regs);
        size := regs.BX;
end;

procedure save_mouse_driver_state(address: Pointer);
begin
        with regs do
        begin
                AX := $16;
                ES := Seg(address^);
                DX := Ofs(address^);
        end;
        Intr($33, regs);
end;

procedure restore_mouse_driver_state(address: Pointer);
begin
        with regs do
        begin
                AX := $17;
                ES := Seg(address^);
                DX := Ofs(address^);
        end;
        Intr($33, regs);
end;
