program test_text_mouse;

uses Crt, Dos, mouse;

var
        ss: String;
        mouse_OK: Boolean;
        count, x, y: Word;
        button, port, IRQ: Byte;
        ver: str6;

procedure display_page(page: Byte);
var
        reg: Registers;
begin
        reg.AH := $05;
        reg.AL := page;
        Intr($10, reg);
end;

begin
        ClrScr;
        WriteLn('  ⥪⮢ ०');
        reset_mouse(mouse_OK, button);
        if not mouse_OK then 
                Halt;
        show_cursor;
        get_mouse_info(ver, port, IRQ);
        WriteLn(' ࠩ  ', ver);
        case port of
                1: Write('bus');
                2: Write('serial');
                3: Write('mouse');
                4: Write('PS/2');
                5: Write('HP');
        end;
        WriteLn('     IRQ ', IRQ, '  ', button, ' ');
        WriteLn('   :');
        repeat
                button := 0;
                get_mouse_button_press(button, count, x ,y);
        until button = 1;
        ClrScr;
        WriteLn(' !');
        WriteLn(' ࠢ  :');
        GotoXY(1, 8);
        TextColor(Yellow);
        TextBackground(Brown);
        for x := 1 to 80 * 16 do
                Write(Chr(x mod 224 + 31));
        TextColor(LightGray);
        TextBackground(Black);
        repeat
                button := 0;
                get_mouse_button_press(button, count, x ,y);
        until button = 2;
        show_cursor;
        GotoXY(1, 3);
        WriteLn('   ,   ய!');
        repeat
                button := 0;
                get_mouse_button_press(button, count, x ,y);
        until button = 1;
        hide_cursor;
        WriteLn(' ࠢ  ,   !');
        repeat
                button := 1;
                get_mouse_button_press(button, count, x ,y);
        until button = 2;
        show_cursor;
        set_text_cursor_shape($FFAB, $A200);
        WriteLn('   ');
        repeat
                button := 0;
                get_mouse_button_press(button, count, x ,y);
        until button = 3;
        Window(1, 1, 80, 6);
        ClrScr;
        Window(1, 1, 80, 25);
        set_mouse_page(0);
        display_page(0);
        ClrScr;
        reset_mouse(mouse_OK, button);
        show_cursor;
        GotoXY(1, 1);
        WriteLn('࠭ 0');
        WriteLn(' 襭 ࠡ    ');
        repeat
                button := 0;
                get_mouse_button_press(button, count, x ,y);
        until button = 1;
        reset_mouse(mouse_OK, button);
        show_cursor;
        ClrScr;
end.
