program fonts;

uses Crt, Graph, graphs;

procedure show_font(font: Word; ss: String);
var
        j: Word;
begin
        for j := 1 to 7 do
        begin
                SetTextStyle(font, HorizDir, j);
                OutTextXY(0, 50 * j, ss);
        end;
        SetTextStyle(font, VertDir, 3);
        OutTextXY(600, 0, 'Press <Enter>:');
        ReadLn;
        ClearDevice;
end;

procedure justify;

const
        ss = 'JUSTIFY';
var
        j, k, l: Word;
begin
        SetTextStyle(SansSerifFont, HorizDir, 1);
        SetFillStyle(SolidFill, LightGray);
        for j:= 0 to 2 do
                for k := 0 to 2 do
                begin
                        Rectangle(50 + j * 150, 15 + 150 * j + 50 * k,
                                200 + j * 150, 60 + 150 * j + 50 * k);
                        FloodFill(60 + j * 150, 20 + 150 * j + 50 * k, White);
                        SetTextJustify(j, k);
                        OutTextXY(120 + j * 150, 30 + 150 * j + 50 * k , ss);
                end;
                OutTextXY(200, 430, 'Press <Enter>');
end;

begin
        open_graph;
        show_font(DefaultFont, 'Default Font');
        show_font(TriplexFont, 'TriplexFont');
        show_font(SmallFont, 'SmallFont');
        show_font(SansSerifFont, 'SansSerifFont');
        show_font(GothicFont, 'GothicFont');
        justify;
        ReadLn;
        close_graph;
end.
