program circle_demo;
uses Crt, Dos;

const
        no_rows = 200;
        no_cols = 320;
        x_max = no_cols div 2;
        x_min = - x_max + 1;
        y_max = no_rows div 2;
        y_min = - y_max + 1;

type
        screenbuffertype = array[0..63999] of Byte;
        screenbufferptr = ^screenbuffertype;
        screentype = record
                buffer: screenbufferptr;
                ytable: array[0..199] of Word;
                width: Word;
                color: Word;
        end;

var
        screen: screentype;
        screen_y: array[0..199] of Word;
        i, j: Word;

procedure calcscreeny(width: Word);
...

procedure init_Graph;
....

procedure close_Graph;
...

procedure set_pixel(x, y: Word; color: Byte);
...

procedure circle(x0, y0, r: Integer);
var
        x, y, s: Integer;
        xx, yy: array[1..8] of Integer;
        k: Word;
begin
        if (x0 + r > x_max) or (x0 - r < x_min) or
                (y0 + r > y_max) or (y0 - r < y_min) then
                        Exit;
        set_pixel(x0 + r, y0, White);
        set_pixel(x0 - r, y0, White);
        set_pixel(x0, y0 + r, White);
        set_pixel(x0, y0 - r, White);
        x := r;
        y := 0;
        s := 3 - 2 * r;
        for k := 1 to 4 do
        begin
                yy[k] := y0;
                xx[4 + k] := x0;
        end;
        xx[1] := x0 + r;
        xx[2] := xx[1];
        xx[3] := x0 - r;
        xx[4] := xx[3];
        yy[5] := y0 + r;
        yy[6] := y0 - r;
        yy[7] := yy[5];
        yy[8] := yy[6];
        while y < x - 1 do
        begin
                Inc(yy[1]);
                yy[3] := yy[1];
                Dec(yy[2]);
                yy[4] := yy[2];
                Inc(xx[5]);
                xx[6] := xx[5];
                Dec(xx[7]);
                xx[8] := xx[7];
                if s <= 0 then
                        s := s + 4 * y + 6
                else
                begin
                        s := s + 4 * (y - x) + 10; Dec(x);
                        Dec(xx[1]); xx[2] := xx[1];
                        Inc(xx[3]); xx[4] := xx[3];
                        Dec(yy[5]); yy[7] := yy[5];
                        Inc(yy[6]); yy[8] := yy[6];
                end;
                Inc(y);
                if x = y then
                        for k := 1 to 4 do
                                set_pixel(xx[k], yy[k], White)
                else
                        for k := 1 to 8 do
                                set_pixel(xx[k], yy[k], White);
        end;
end;

begin
        init_Graph;
        Circle(140, 60, 20);
        ReadLn;
        close_Graph;
end.
