program test_graph_pages;

uses
        Crt, Dos, Graph;

var
        GraphDriver, GraphMode, k: Integer;
        ss, tt: String;
        reg: Registers;

procedure set_cursor_position(page, x, y: Byte);
...

procedure write_chars(page, x, y: Byte; ch0: Char; attr: Byte; multiplicity: Word);
...

procedure write_string(page, x, y: Byte; ss: String; attr: Byte);
...

begin
        GraphDriver := VGA;
        GraphMode := VGAMed;
        InitGraph(GraphDriver, GraphMode, ' ');
        write_string(0, 20, 0, 'Page 0', Yellow);
        write_string(0, 20, 1, 'Press <Enter>: ', Yellow);
        write_string(1, 30, 0, 'Page 1', Magenta);
        write_string(1, 30, 1, 'Press <Enter>: ', Magenta);
        SetVisualPage(0);
        SetActivePage(1);
        ss := 'XX';
        for k := 0 to 25 do
        begin
                Str(k, tt);
                tt := tt + '  ' + ss;
                if k <= 9 then
                        tt := ' ' + tt;
                write_string(1, 0, k, tt, LightGreen);
                Line(0, 13 + 14 * k, 8 * Length(tt), 13 + 14 * k);
                ss := ss + 'XX';
        end;
        SetColor(White);
        SetFillStyle(LtBkSlashFill, LightRed);
        Bar(500, 0, 600, 349);
        ReadLn;
        SetVisualPage(1);
        SetActivePage(0);
        SetColor(LightMagenta);
        SetFillStyle(XhatchFill, LightCyan);
        FillEllipse(500, 175, 137, 100);
        ReadLn;
        SetVisualPage(0);
        ReadLn;
        SetVisualPage(1);
        ReadLn;
        RestoreCRTMode;
end.
