unit graphs3d;

interface

uses
        Dos, Crt, Graph, bgi_chr;

type
        vector = array[1..3] of Real;
        projection = array[1..2] of vector;

var
        abs_x_center, abs_y_center: Integer;

procedure open_graph;
procedure close_graph;
procedure out_text_XY(ss: String; x, y: Integer; color: Word);
procedure put_pixel(x, y: Integer; color: Word);
procedure norm_line(x0, y0, x1, y1: Integer; color: Word);
procedure compute_isometric_matrix(var P: projection);
procedure compute_dimetric_matrix(alpha: Real; var P: projection);
procedure compute_oblique_matrix(alpha: Real; var P: projection);
procedure project(const P: projection; const x, y, z: Real; const u0, v0: Integer; var u, v: Integer);
