procedure compute_dimetric_matrix(alpha: Real; var P: projection);
var
        t: Real;
begin
        alpha := Pi * alpha / 180.0;
        P[1, 1] := -1.0 / Sqrt(2.0);
        P[1, 2] := -P[1, 1];
        P[1, 3] := 0.0;
        t := Sin(alpha) / Cos(alpha);
        P[2, 1] := t * P[1, 1];
        P[2, 2] := P[2, 1];
        P[2, 3] := Sqrt(1.0 - Sqr(t));
end;
