program sprite;

uses
        Crt, Graph, graphs;

type
        bytearraytype = array[0..65534] of Byte;
        bytearrayptr = ^bytearraytype;
        spritetype = record
                height, width: Word;
                data: bytearrayptr;
        end;

var
        backgroundsprite, testsprite: spritetype;
        xd, yd, ox, oy, i, x, y: Integer;

procedure KillSprite(var sprite: spritetype);
...

procedure CreateSprite(var sprite: spritetype; width, height: Word);
...

procedure GetSprite(var sprite: spritetype; x1, y1, x2, y2: Word);
...

procedure DrawSprite(var sprite: spritetype; x, y: Word);
...

begin
        open_graph;
        SetGraphMode(EGA64lo);
        Line(10, 1, 10, 20);
        Line(1, 10, 20, 10);
        Line(1, 1, 20, 20);
        Line(20, 1, 1, 20);
        GetSprite(testsprite, 0, 0, 21, 21);
        x := 0;
        y := 0;
        xd := 1;
        yd := 1;
        while not KeyPressed do
        begin
                DrawSprite(testsprite, x, y);
                Inc(x, xd);
                Inc(y, yd);
                if (x = GetMaxX - 20) or (x = -20) then
                        xd := -xd;
                if (y = GetMaxY - 20) or (y = -20) then
                        yd := -yd;
        end;
        ReadLn;

        ClearViewPort;
        SetColor(Green);
        for i := 0 to 100 do
                Line(Random(GetMaxX), Random(GetMaxY), Random(GetMaxX), Random(GetMaxY));
        x := 0;
        y := 0;
        xd := 1;
        yd := 1;
        while not KeyPressed do
        begin
                DrawSprite(testsprite, x, y);
                Inc(x, xd);
                Inc(y, yd);
                if (x = GetMaxX - 20) or (x = -20) then
                        xd := -xd;
                if (y = GetMaxY - 20) or (y = -20) then
                        yd := -yd;
        end;
        ReadLn;

        ClearViewPort;
        SetColor(Green);
        for i := 0 to 100 do
                Line(Random(GetMaxX), Random(GetMaxY), Random(GetMaxX), Random(GetMaxY));
        x := 0;
        y := 0;
        xd := 1;
        yd := 1;
        while not KeyPressed do
        begin
                GetSprite(backgroundsprite, x, y, x + 22, y + 22);
                DrawSprite(testsprite, x, y);
                ox := x;
                oy := y;
                Inc(x, xd);
                Inc(y, yd);
                if (x = GetMaxX - 20) or (x = -20) then
                        xd := -xd;
                if (y = GetMaxY - 20) or (y = -20) then
                        yd := -yd;
                DrawSprite(backgroundsprite, ox, oy);
        end;
        DrawSprite(testsprite, x, y);
        ReadLn;
        close_graph;
end.
