{$S+}
{$N+}
program bisection;

uses
        Crt;

type
        real = Extended;

const
        eps = 1.0e-17;
var
        x0, x1, midpt: Real;
        depth: Word;

function F(x: Real): Real;
begin
        F := x * x - 2.0;
end;

procedure bisect(var x0, x1: Real);
begin
        if KeyPressed then
                Halt;
        Inc(depth);
        midpt := 0.5 * (x0 + x1);
        if F(x1) - F(x0) < eps then
                Exit;
        if F(midpt) >= 0.0 then
                x1 := midpt
        else
                x0 := midpt;
        bisect(x0, x1);
end;

begin
        depth := 0;
        x0 := 0.0;
        x1 := 5.0;
        bisect(x0, x1);
        ClrScr;
        WriteLn('襭 ࠢ F(x) = 0 ਡ⥫쭮 ', midpt:22:18);
        WriteLn('㡨 ४ᨨ ', depth);
        WriteLn(' <Enter>');
        ReadLn;
end.
