program peano;

uses
        Crt, Graph, graphs;

var
        ch: Char;
        x, y: Integer;

procedure draw_Z(n: Word; plus: Boolean);

procedure rotate(plus: Boolean);

var
        t: Integer;

begin
        if plus then
        begin
                t := x;
                x := -y;
                y := t;
        end
        else
        begin
                t := x;
                x := y;
                y := -t;
        end;
end;

begin
        if n > 0 then
        begin
                draw_Z(n - 1, plus);
                LineRel(x, y);
                draw_Z(n - 1, not plus);
                LineRel(x, y);
                draw_Z(n - 1, plus);
                rotate(plus);
                LineRel(x, y);
                rotate(plus);
                draw_Z(n - 1, not plus);
                LineRel(x, y);
                draw_Z(n - 1, plus);
                LineRel(x, y);
                draw_Z(n - 1, not plus);
                rotate(not plus);
                LineRel(x, y);
                rotate(not plus);
                draw_Z(n - 1, plus);
                LineRel(x, y);
                draw_Z(n - 1, not plus);
                LineRel(x, y);
                draw_Z(n - 1, plus);
        end;
end;

begin
        open_graph;
        MoveTo(0, 0);
        x := 5;
        y := 0;
        draw_Z(4, True);
        OutTextXY(500, 460, 'Press <Enter>:');
        ReadLn;
        close_graph;
end.
