procedure play_note_mono(octav, note, duration: Word);
begin
        port[mono] := $A0;
        port[mono + $0001] := Lo(note);
        port[mono] := $B0;
        port[mono + $0001] := key_on + octav + Hi(note);
        Delay(duration);
        port[mono] := $B0;
        port[mono + $0001] := key_off + octav + Hi(note);
end;

procedure play_note_stereo(octav, note, duration: Word);
begin
        port[Left_Stereo] := $A0;
        port[Left_Stereo + $0001] := Lo(note);
        port[Right_Stereo] := $A0;
        port[Right_Stereo + $0001] := Lo(note);
        port[Left_Stereo] := $B0;
        port[Left_Stereo + $0001] := key_on + octav + Hi(note);
        port[Right_Stereo] := $B0;
        port[Right_Stereo + $0001] := key_on + octav + Hi(note);
        Delay(duration);
        port[Left_Stereo] := $B0;
        port[Left_Stereo + $0001] := key_off + octav + Hi(note);
        port[Right_Stereo] := $B0;
        port[Right_Stereo + $0001] := key_off + octav + Hi(note);
end;
