unit symm_mat;

interface

const
        max_dim = 50;

type
        symmetric_matrix = array[1..max_dim, 1..max_dim] of Real;
        vector = array[0..max_dim] of Real;
        str4 = String[4];

var
        dim: Word;

procedure get_matrix(var A: symmetric_matrix);
procedure print_matrix(var A: symmetric_matrix; name: str4);
procedure iterate(const A: symmetric_matrix; var v: vector;
                var r: Real; var fail: Boolean);
procedure QR_algorithm(var A: symmetric_matrix;
                var char_root: vector; var W: symmetric_matrix);
